
#include "HEAD.h"

#include "node.h"

#include "visitprocs.h"

#include "gsdescr.h"

extern void free();

extern char *malloc();

#include "obstack.h"

static struct obstack TreeSpace;

#define obstack_chunk_alloc malloc

#define obstack_chunk_free free

char* TreeNodeAlloc(size) int size;

{return (obstack_alloc(&TreeSpace, size));}

void InitTree() { obstack_init(&TreeSpace); }

NODEPTR Mkinteger(_coordref,_tr1)
POSITION *_coordref;
int _tr1;
{
_TSPinteger n;
n = (_TSPinteger) TreeNodeAlloc (sizeof (struct _TSinteger));
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;

n->_ATValue=_tr1;
return ((NODEPTR) n);
}

NODEPTR MkRoot(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPRoot n;
n = (_TPPRoot) TreeNodeAlloc (sizeof (struct _TPRoot));
n->_proc =_VS1Root;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOption)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkOpt1(_coordref,_tr1,_tr2)
POSITION *_coordref;
NODEPTR _tr1;
NODEPTR _tr2;
{_TPPOpt1 n;
n = (_TPPOpt1) TreeNodeAlloc (sizeof (struct _TPOpt1));
n->_proc =_VS1Opt1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOption)_tr1;
n->_desc2= (_TSPOption)_tr2;
return ( (NODEPTR) n);
}

NODEPTR MkOpt2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPOpt2 n;
n = (_TPPOpt2) TreeNodeAlloc (sizeof (struct _TPOpt2));
n->_proc =_VS1Opt2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPFrontend)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkOpt3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPOpt3 n;
n = (_TPPOpt3) TreeNodeAlloc (sizeof (struct _TPOpt3));
n->_proc =_VS1Opt3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPTable)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkOpt4(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPOpt4 n;
n = (_TPPOpt4) TreeNodeAlloc (sizeof (struct _TPOpt4));
n->_proc =_VS1Opt4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPDirect)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkOpt5(_coordref)
POSITION *_coordref;
{_TPPOpt5 n;
n = (_TPPOpt5) TreeNodeAlloc (sizeof (struct _TPOpt5));
n->_proc =_VS1Opt5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkF1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPF1 n;
n = (_TPPF1) TreeNodeAlloc (sizeof (struct _TPF1));
n->_proc =_VS1F1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkF2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPF2 n;
n = (_TPPF2) TreeNodeAlloc (sizeof (struct _TPF2));
n->_proc =_VS1F2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkF3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPF3 n;
n = (_TPPF3) TreeNodeAlloc (sizeof (struct _TPF3));
n->_proc =_VS1F3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkT1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPT1 n;
n = (_TPPT1) TreeNodeAlloc (sizeof (struct _TPT1));
n->_proc =_VS1T1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkT2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPT2 n;
n = (_TPPT2) TreeNodeAlloc (sizeof (struct _TPT2));
n->_proc =_VS1T2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPMode)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkT3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPT3 n;
n = (_TPPT3) TreeNodeAlloc (sizeof (struct _TPT3));
n->_proc =_VS1T3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPMode)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkM1(_coordref)
POSITION *_coordref;
{_TPPM1 n;
n = (_TPPM1) TreeNodeAlloc (sizeof (struct _TPM1));
n->_proc =_VS1M1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM2(_coordref)
POSITION *_coordref;
{_TPPM2 n;
n = (_TPPM2) TreeNodeAlloc (sizeof (struct _TPM2));
n->_proc =_VS1M2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM3(_coordref)
POSITION *_coordref;
{_TPPM3 n;
n = (_TPPM3) TreeNodeAlloc (sizeof (struct _TPM3));
n->_proc =_VS1M3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM4(_coordref)
POSITION *_coordref;
{_TPPM4 n;
n = (_TPPM4) TreeNodeAlloc (sizeof (struct _TPM4));
n->_proc =_VS1M4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM5(_coordref)
POSITION *_coordref;
{_TPPM5 n;
n = (_TPPM5) TreeNodeAlloc (sizeof (struct _TPM5));
n->_proc =_VS1M5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM6(_coordref)
POSITION *_coordref;
{_TPPM6 n;
n = (_TPPM6) TreeNodeAlloc (sizeof (struct _TPM6));
n->_proc =_VS1M6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM7(_coordref)
POSITION *_coordref;
{_TPPM7 n;
n = (_TPPM7) TreeNodeAlloc (sizeof (struct _TPM7));
n->_proc =_VS1M7;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkM8(_coordref)
POSITION *_coordref;
{_TPPM8 n;
n = (_TPPM8) TreeNodeAlloc (sizeof (struct _TPM8));
n->_proc =_VS1M8;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkD1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPD1 n;
n = (_TPPD1) TreeNodeAlloc (sizeof (struct _TPD1));
n->_proc =_VS1D1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPStackOpt)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkD2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPD2 n;
n = (_TPPD2) TreeNodeAlloc (sizeof (struct _TPD2));
n->_proc =_VS1D2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPCodeOpt)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkD3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPD3 n;
n = (_TPPD3) TreeNodeAlloc (sizeof (struct _TPD3));
n->_proc =_VS1D3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPErrorOpt)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS1 n;
n = (_TPPDS1) TreeNodeAlloc (sizeof (struct _TPDS1));
n->_proc =_VS1DS1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPinteger)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS2(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS2 n;
n = (_TPPDS2) TreeNodeAlloc (sizeof (struct _TPDS2));
n->_proc =_VS1DS2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS3(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS3 n;
n = (_TPPDS3) TreeNodeAlloc (sizeof (struct _TPDS3));
n->_proc =_VS1DS3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS4(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS4 n;
n = (_TPPDS4) TreeNodeAlloc (sizeof (struct _TPDS4));
n->_proc =_VS1DS4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS5(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS5 n;
n = (_TPPDS5) TreeNodeAlloc (sizeof (struct _TPDS5));
n->_proc =_VS1DS5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDS6(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDS6 n;
n = (_TPPDS6) TreeNodeAlloc (sizeof (struct _TPDS6));
n->_proc =_VS1DS6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPinteger)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC1(_coordref)
POSITION *_coordref;
{_TPPDC1 n;
n = (_TPPDC1) TreeNodeAlloc (sizeof (struct _TPDC1));
n->_proc =_VS1DC1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkDC2(_coordref)
POSITION *_coordref;
{_TPPDC2 n;
n = (_TPPDC2) TreeNodeAlloc (sizeof (struct _TPDC2));
n->_proc =_VS1DC2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkDC3(_coordref)
POSITION *_coordref;
{_TPPDC3 n;
n = (_TPPDC3) TreeNodeAlloc (sizeof (struct _TPDC3));
n->_proc =_VS1DC3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkDC4(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC4 n;
n = (_TPPDC4) TreeNodeAlloc (sizeof (struct _TPDC4));
n->_proc =_VS1DC4;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC5(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC5 n;
n = (_TPPDC5) TreeNodeAlloc (sizeof (struct _TPDC5));
n->_proc =_VS1DC5;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPinteger)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC6(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC6 n;
n = (_TPPDC6) TreeNodeAlloc (sizeof (struct _TPDC6));
n->_proc =_VS1DC6;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPinteger)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC7(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC7 n;
n = (_TPPDC7) TreeNodeAlloc (sizeof (struct _TPDC7));
n->_proc =_VS1DC7;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC8(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC8 n;
n = (_TPPDC8) TreeNodeAlloc (sizeof (struct _TPDC8));
n->_proc =_VS1DC8;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC9(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC9 n;
n = (_TPPDC9) TreeNodeAlloc (sizeof (struct _TPDC9));
n->_proc =_VS1DC9;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC10(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC10 n;
n = (_TPPDC10) TreeNodeAlloc (sizeof (struct _TPDC10));
n->_proc =_VS1DC10;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDC11(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDC11 n;
n = (_TPPDC11) TreeNodeAlloc (sizeof (struct _TPDC11));
n->_proc =_VS1DC11;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPOnOff)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDE1(_coordref,_tr1)
POSITION *_coordref;
NODEPTR _tr1;
{_TPPDE1 n;
n = (_TPPDE1) TreeNodeAlloc (sizeof (struct _TPDE1));
n->_proc =_VS1DE1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
n->_desc1= (_TSPinteger)_tr1;
return ( (NODEPTR) n);
}

NODEPTR MkDE2(_coordref)
POSITION *_coordref;
{_TPPDE2 n;
n = (_TPPDE2) TreeNodeAlloc (sizeof (struct _TPDE2));
n->_proc =_VS1DE2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkDE3(_coordref)
POSITION *_coordref;
{_TPPDE3 n;
n = (_TPPDE3) TreeNodeAlloc (sizeof (struct _TPDE3));
n->_proc =_VS1DE3;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkSW1(_coordref)
POSITION *_coordref;
{_TPPSW1 n;
n = (_TPPSW1) TreeNodeAlloc (sizeof (struct _TPSW1));
n->_proc =_VS1SW1;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

NODEPTR MkSW2(_coordref)
POSITION *_coordref;
{_TPPSW2 n;
n = (_TPPSW2) TreeNodeAlloc (sizeof (struct _TPSW2));
n->_proc =_VS1SW2;
n->_pos.line = _coordref->line; n->_pos.col = _coordref->col;
return ( (NODEPTR) n);
}

#ifndef GETintegerValue
#define GETintegerValue(x) (x)
#endif

void SourceLeaf(d) GRUNDSYMBOLDESKRIPTOR *d;
{_incrnodestack ();
switch (d->SyntaxCode) {

case 2: _nst[_nsp] =Mkinteger(&(d->Pos),GETintegerValue (d->Attr)); break;
}}

